const express = require('express');
const router = express.Router();
const multer = require('multer');
const authorize = require('../../../../middlewares/authorize-sapps');
const employeeGroupService = require('./employeeGroup.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new employeeGroup
 * @param {Object} req.body - The employeeGroup data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created employeeGroup
 */
function create(req, res, next) {
    employeeGroupService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all employeeGroups
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of employeeGroups
 */
function getAll(req, res, next) {
    employeeGroupService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of employeeGroup objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of employeeGroup objects
 */
function option(req, res, next) {
    employeeGroupService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of employeeGroups matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of employeeGroups
 */
function count(req, res, next) {
    employeeGroupService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing employeeGroup
 * @param {number} req.params.id - The employeeGroup ID to be updated
 * @param {Object} req.body - The employeeGroup data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated employeeGroup
 */
function update(req, res, next) {
    employeeGroupService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a employeeGroup
 * @param {number} req.params.id - The employeeGroup ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    employeeGroupService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
